﻿using UnityEngine;
using System.Collections; 
using System;
using System.Runtime.InteropServices;
using System.IO;

public class VrpnManager : MonoBehaviour {

	[ StructLayout( LayoutKind.Sequential, Pack=0)]
	public struct TimeVal
	{
		public UInt32 tv_sec;
		public UInt32 tv_usec;
	}
	
	public string ServerAddress = "";
	public static bool debug_flag = false;
	public bool ShowDebug = false;
	public static bool initialized = false;
	
	private StringWriter debug_writer;
	private string[] debug_text;
	private int debug_index = 0;
	private int debug_buffer_pos = 0;
	private int debug_buffer_max = 500;
	private int debug_lines = 8;

	[DllImport ("E:/Users/CafeMedia/Google Drive/Skoleting/Masteroppgave/Unity/Assets/Plugins/VRPN/VrpnProject.dll")]
	private static extern void VRPNServerStart(string location);

	[DllImport("E:/Users/CafeMedia/Google Drive/Skoleting/Masteroppgave/Unity/Assets/Plugins/VRPN/VrpnProject.dll")]
	private static extern void VRPNServerStop();

	[DllImport("E:/Users/CafeMedia/Google Drive/Skoleting/Masteroppgave/Unity/Assets/Plugins/VRPN/VrpnProject.dll")]
	private static extern void VRPNServerLoop();

	[DllImport("E:/Users/CafeMedia/Google Drive/Skoleting/Masteroppgave/Unity/Assets/Plugins/VRPN/VrpnProject.dll")]
	private static extern void VRPNSetOutput(int handle);

	// Use this for initialization
	void Start () {

		Debug.Log("VRPNManager: Start");

		//Access external server
		VRPNServerStart(ServerAddress);
		initialized = true;
	}

	void OnDisable()
	{
		Debug.Log("VRPNManager: OnDisable");
		// Shut down connection to server
		VRPNServerStop();
	}
	
	// Update is called once per frame
	void Update () {
		//Run the server loop
		VRPNServerLoop();
	}

	public static bool TimeValGreater(ref TimeVal tv1, ref TimeVal tv2)
	{
		if (tv1.tv_sec > tv2.tv_sec) 
			return true;
		if ((tv1.tv_sec == tv2.tv_sec) && (tv1.tv_usec > tv2.tv_usec)) 
			return true;
		return false;
	}

	public enum Tracker_Types {
		vrpn_3DConnexion_Navigator,
		vrpn_3DConnexion_SpaceBall5000,
		vrpn_3DConnexion_SpaceExplorer,
		vrpn_3DConnexion_SpaceMouse,
		vrpn_3DConnexion_Traveler,
		vrpn_3DMicroscribe,
		vrpn_5dt,
		vrpn_5dt16,
		vrpn_Analog_USDigital_A2,
		vrpn_Auxiliary_Logger_Server_Generic,
		vrpn_Button_5DT_Server,
		vrpn_Button_NI_DIO24,
		vrpn_Button_PinchGlove,
		vrpn_Button_Python,
		vrpn_Button_SerialMouse,
		vrpn_CerealBox,
		vrpn_Dial_Example,
		vrpn_DirectXFFJoystick,
		vrpn_DirectXRumblePad,
		vrpn_GlobalHapticsOrb,
		vrpn_Imager_Stream_Buffer,
		vrpn_ImmersionBox,
		vrpn_JoyFly,
		vrpn_Joylin,
		vrpn_Joystick,
		vrpn_Joywin32,
		vrpn_Keyboard,
		vrpn_Magellan,
		vrpn_Mouse,
		vrpn_National_Instruments,
		vrpn_NI_Analog_Output,
		vrpn_nikon_controls,
		vrpn_Phantom,
		vrpn_Poser_Analog,
		vrpn_Radamec_SPI,
		vrpn_raw_SGIBox,
		vrpn_SGIBOX,
		vrpn_Spaceball,
		vrpn_Tek4662,
		vrpn_TimeCode_Generator,
		vrpn_Tng3,
		vrpn_Tracker_3DMouse,
		vrpn_Tracker_3Space,
		vrpn_Tracker_AnalogFly,
		vrpn_Tracker_ButtonFly,
		vrpn_Tracker_Crossbow,
		vrpn_Tracker_DTrack,
		vrpn_Tracker_Dyna,
		vrpn_Tracker_Fastrak,
		vrpn_Tracker_Flock,
		vrpn_Tracker_Flock_Parallel,
		vrpn_Tracker_GPS,
		vrpn_Tracker_InterSense,
		vrpn_Tracker_Liberty,
		vrpn_Tracker_MotionNode,
		vrpn_Tracker_NULL,
		vrpn_Tracker_PhaseSpace,
		vrpn_VPJoystick,
		vrpn_Wanda,
		vrpn_WiiMote,
		vrpn_XInputGamepad,
		vrpn_Xkeys_Desktop,
		vrpn_Xkeys_Jog_And_Shuttle,
		vrpn_Xkeys_Joystick,
		vrpn_Xkeys_Pro,
		vrpn_Zaber };
}
