﻿using UnityEngine;
using System.Collections;

public class IKControlAlex : MonoBehaviour {

	protected Animator animator;

	public bool ikActive = false;
	public Transform rightHandObj = null;
	public Transform leftHandObj = null;

	public Transform leftFootObj = null;
	public Transform rightFootObj = null;

	public Transform lookObj = null;
	public Transform BodyTransform = null;

	void Start()
	{
		animator = GetComponent<Animator>();

		if (animator) {
			Debug.Log ("Setting bodytransform");
			animator.bodyRotation = BodyTransform.rotation;
			animator.bodyPosition = BodyTransform.position;
			animator.rootRotation = BodyTransform.rotation;
			animator.rootPosition = BodyTransform.position;
		}
	}

	//a callback for calculating IK
	void OnAnimatorIK()
	{
		if (animator)
		{


			//if the IK is active, set the position and rotation directly to the goal. 
			if (ikActive)
			{

				// Set the look target position, if one has been assigned
				if (lookObj != null)
				{
					animator.SetLookAtWeight(1);
					animator.SetLookAtPosition(lookObj.position);

					animator.SetIKPositionWeight(AvatarIKGoal.RightFoot, 1);
					animator.SetIKPosition(AvatarIKGoal.RightFoot, rightFootObj.position);

					animator.SetIKPositionWeight(AvatarIKGoal.LeftFoot, 1);
					animator.SetIKPosition(AvatarIKGoal.LeftFoot, leftFootObj.position);
				}

				// Set the right hand target position and rotation, if one has been assigned
				if (rightHandObj != null)
				{
					animator.SetIKPositionWeight(AvatarIKGoal.RightHand, 1);
					animator.SetIKPosition(AvatarIKGoal.RightHand, rightHandObj.position);
				}

				// Set the right hand target position and rotation, if one has been assigned
				if (leftHandObj != null)
				{
					animator.SetIKPositionWeight(AvatarIKGoal.LeftHand, 1);
					animator.SetIKPosition(AvatarIKGoal.LeftHand, leftHandObj.position);
				}

			}

			//if the IK is not active, set the position and rotation of the hand and head back to the original position
			else
			{
				animator.SetIKPositionWeight(AvatarIKGoal.RightHand, 0);
				animator.SetIKRotationWeight(AvatarIKGoal.RightHand, 0);
				animator.SetIKPositionWeight(AvatarIKGoal.LeftHand, 0);
				animator.SetIKRotationWeight(AvatarIKGoal.LeftHand, 0);
				animator.SetLookAtWeight(0);
			}
		}
	}
}
