#define VRPN_POS (1)

#include "vrpn_Tracker.h"
#include "quat.h"
#include <list>
typedef std::list<vrpn_TRACKERCB* > TrackerPosList;

class VRPNTrackerInstance {

public:

	VRPNTrackerInstance(const char*);
	~VRPNTrackerInstance();

	vrpn_Tracker_Remote* getTracker();

	void setReportTypes(int);
	int getReportTypes();
	void setMaxReports(int);

	//populate tracker report for given time (most recent if NULL) and sensor number (default 0)
	void getPosReport(vrpn_TRACKERCB*, timeval*, int);

	int getNumPosReports();

	//populate list of all reports for given sensor number (default 0)
	void getPosReports(vrpn_TRACKERCB**, int&);

	//add tracker reports to list (delete oldest if list over maxReports)
	void addPosReport(const vrpn_TRACKERCB&);

	//remove all reports
	void purgeReports();

protected:
	//capture position
	int types;
	vrpn_Tracker_Remote* tracker;
	int maxReports;

	TrackerPosList pos;

};